Description

It seems that since Foreman version 1.10 (at least 1.10.3) I need to give a user administrator permissions to access

/api/smart_class_parameters

Is this by design?

I also can't seem to limit access to a specific search on "Lookup key" anymore, is this by design?

Related issues:

Related to Foreman - Refactor #10832: Make LookupKey an STI for puppet and va... Closed 06/16/2015

Related to Foreman - Bug #14546: No ability to restrict *_external_variables ... Closed 04/08/2016

Related to Foreman - Bug #15321: Cannot save smart parameter bookmarks Resolved 06/07/2016

Associated revisions

Revision 3fe2ea3d - 05/27/2016 06:48 AM - Ori Rabin

Fixes #14546 - ability to restrict *_external_variables

Fixes #14535 - corrects permissions for smart class parameters

History

#1 - 04/08/2016 03:09 AM - Dominic Cleal

- Category set to Users, Roles and Permissions

- Status changed from New to Need more information

The *_external_variables permissions should give access to this API, please check you've assigned it to the user.  If that doesn't work, please attach

production.log during the access, with debugging and the permissions logger enabled: http://theforeman.org/manuals/1.10/index.html#7.2Debugging

#2 - 04/08/2016 05:33 AM - Sander Hoentjen

Dominic Cleal wrote:

The *_external_variables permissions should give access to this API, please check you've assigned it to the user.

 Yes, I have assigned those. With 1.9 I used search for that as well, so to be sure I removed and re-added the permissions but without any success.

2016-04-08 11:29:33 [app] [I] Started GET

"/api/smart_class_parameters?search=key+%3D+some_key+and+puppetclass+%3D+some%3A%3Aclass" for 10.99.0.232 at 2016-04-08 11:29:33

+0200

2016-04-08 11:29:33 [app] [I] Processing by Api::V2::SmartClassParametersController#index as JSON

2016-04-08 11:29:33 [app] [I]   Parameters: {"search"=>"key = some_key and puppetclass = some::class", "apiv"=>"v2",

"smart_class_parameter"=>{}}

2016-04-08 11:29:33 [app] [I] Authorized user some_user(Some User)

2016-04-08 11:29:33 [permissions] [D] checking permission view_external_variables

2016-04-08 11:29:33 [permissions] [D]

2016-04-08 11:29:33 [permissions] [D] no filters found for given permission

2016-04-08 11:29:33 [permissions] [D] checking permission view_external_variables

2016-04-08 11:29:33 [permissions] [D]
2016-04-08 11:29:33 [permissions] [D] no filters found for given permission

2016-04-08 11:29:33 [app] [I]   Rendered api/v2/smart_class_parameters/index.json.rabl within api/v2/layouts/index_layout (10.4ms)

2016-04-08 11:29:33 [permissions] [D] checking permission view_external_variables

2016-04-08 11:29:33 [permissions] [D]

2016-04-08 11:29:33 [permissions] [D] no filters found for given permission

#3 - 04/08/2016 05:43 AM - Dominic Cleal

- Related to Refactor #10832: Make LookupKey an STI for puppet and variable keys added

#4 - 04/08/2016 05:44 AM - Dominic Cleal

- Subject changed from /api/smart_class_parameters needs administrator permissions? to /api/smart_class_parameters needs administrator

permissions

- Status changed from Need more information to New

The authorisation step is checking for a resource type that doesn't match what's stored in the seeded permissions, it's looking up:

permissions.resource_type = 'PuppetclassLookupKey'.  Prior to #10832, the resource type would always be LookupKey, but

db/seeds.d/03-permissions.rb isn't updated with the new PuppetLookupKey/VariableLookupKey resource types.

#5 - 04/08/2016 06:03 AM - Dominic Cleal

- Related to Bug #14546: No ability to restrict *_external_variables with search anymore added

#6 - 05/16/2016 10:38 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Ori Rabin

- Pull request https://github.com/theforeman/foreman/pull/3530 added

#7 - 05/27/2016 07:03 AM - Ori Rabin

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 3fe2ea3df66bd2e2e35416df090323f0e54a85ef.

#8 - 05/27/2016 10:34 AM - Dominic Cleal

- translation missing: en.field_release set to 136

#9 - 12/26/2016 08:36 AM - Tomer Brisker

- Related to Bug #15321: Cannot save smart parameter bookmarks added
